"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/engine/InMemory.ts
var InMemory_exports = {};
__export(InMemory_exports, {
  InMemoryEngine: () => InMemoryEngine
});
module.exports = __toCommonJS(InMemory_exports);

// src/engine/DataEngine.ts
var DataEngine = class _DataEngine {
  static IsInstance(object) {
    return object instanceof _DataEngine;
  }
};

// src/utils/IterableView.ts
var IterableView = class _IterableView {
  static Create(length, fill) {
    return new Array(length).fill(fill);
  }
  static Copy(array) {
    return array.slice();
  }
  static Read(array, start, length = array.length - start) {
    return array.slice(start, start + length);
  }
  static Update(array, start, data) {
    for (let i = 0, len = Math.min(data.length, array.length - start); i < len; i++) {
      const j = start + i;
      array[j] = data[i];
    }
    return array;
  }
  static Ensure(array, len, fill) {
    if (array.length >= len) {
      return array;
    }
    const extended = new Array(len - array.length).fill(fill);
    array.push(...extended);
    return array;
  }
  read(array, start, length = array.length - start) {
    return _IterableView.Read(array, start, length);
  }
  update(array, start, data) {
    return _IterableView.Update(array, start, data);
  }
  ensure(array, length, fill) {
    return _IterableView.Ensure(array, length, fill);
  }
};

// src/engine/InMemory.ts
var InMemoryEngine = class extends DataEngine {
  data;
  constructor() {
    super();
    this.data = [];
  }
  async exists(file) {
    return !!this.data.length;
  }
  async boot(file) {
  }
  async create(file, initialData) {
    this.data.push(...initialData);
  }
  async open(file) {
  }
  async close() {
    this.data.length = 0;
  }
  async size() {
    return this.data.length;
  }
  async read(start, length) {
    if (length === void 0) {
      length = await this.size() - start;
    }
    return IterableView.Read(this.data, start, length);
  }
  async update(start, data) {
    const size = await this.size();
    const length = Math.min(data.length, size - start);
    const chunk = data.slice(0, length);
    IterableView.Update(this.data, start, chunk);
    return chunk;
  }
  async append(data) {
    this.data.push(...data);
  }
  async truncate(size) {
    this.data.length = size;
  }
  async unlink(file) {
    this.clear();
  }
  clear() {
    this.data.length = 0;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  InMemoryEngine
});
