export type UpdateToRepoFn<T> = (id: string, node: T) => Promise<void>;
export type DeleteFromRepoFn = (id: string) => Promise<void>;
export interface KlafRepositorySynchronizerConstructorArguments<T> {
    updateFn: UpdateToRepoFn<T>;
    deleteFn: DeleteFromRepoFn;
}
export declare class KlafRepositorySynchronizer<T> {
    private _deleteQueue;
    private _updateQueue;
    private _updateFn;
    private _deleteFn;
    private _dirty;
    constructor({ updateFn, deleteFn, }: KlafRepositorySynchronizerConstructorArguments<T>);
    addToUpdateQueue(id: string, node: T): void;
    deleteFromQueue(id: string): void;
    isNeedToSync(): boolean;
    sync(): Promise<void>;
}
