import type { OpenMode, Stats } from 'node:fs';
import { Buffer } from 'node:buffer';
import { Ryoiki } from 'ryoiki';
import { DataEngine } from './DataEngine';
export declare class FileSystemEngine extends DataEngine {
    protected static Open(file: string, mode: OpenMode): Promise<number>;
    protected static Read(fd: number, buffer: Buffer, offset: number, length: number, position: number): Promise<number>;
    protected static Write(fd: number, buffer: NodeJS.ArrayBufferView, offset: number, length: number, position: number): Promise<number>;
    protected static Truncate(fd: number, size: number): Promise<void>;
    protected static Close(fd: number): Promise<void>;
    protected static FStats(fd: number): Promise<Stats>;
    protected fd: number;
    protected readonly locker: Ryoiki;
    constructor();
    exists(file: string): Promise<boolean>;
    boot(file: string): Promise<void>;
    create(file: string, initialData: number[]): Promise<void>;
    open(file: string): Promise<void>;
    close(): Promise<void>;
    size(): Promise<number>;
    read(start: number, length?: number): Promise<number[]>;
    update(start: number, data: number[]): Promise<number[]>;
    append(data: number[]): Promise<void>;
    truncate(size: number): Promise<void>;
    unlink(file: string): Promise<void>;
}
