import { DataEngine } from './DataEngine';
export declare class InMemoryEngine extends DataEngine {
    protected readonly data: number[];
    constructor();
    exists(file: string): Promise<boolean>;
    boot(file: string): Promise<void>;
    create(file: string, initialData: number[]): Promise<void>;
    open(file: string): Promise<void>;
    close(): Promise<void>;
    size(): Promise<number>;
    read(start: number, length?: number): Promise<number[]>;
    update(start: number, data: number[]): Promise<number[]>;
    append(data: number[]): Promise<void>;
    truncate(size: number): Promise<void>;
    unlink(file: string): Promise<void>;
    clear(): void;
}
