import { DataEngine } from './DataEngine';
declare abstract class WebWorkerStrategy extends DataEngine {
    readonly directoryHandle: FileSystemDirectoryHandle;
    readonly fileHandle: FileSystemFileHandle;
    constructor(directoryHandle: FileSystemDirectoryHandle, fileHandle: FileSystemFileHandle);
}
export declare class WebWorkerEngine extends DataEngine {
    protected booting: boolean;
    protected strategy: WebWorkerStrategy;
    constructor();
    get fileHandle(): FileSystemFileHandle | null;
    private _getHandles;
    private _getBestStrategy;
    exists(file: string): Promise<boolean>;
    boot(file: string): Promise<void>;
    create(file: string, initialData: number[]): Promise<void>;
    open(file: string): Promise<void>;
    close(): Promise<void>;
    size(): Promise<number>;
    read(start: number, length?: number): Promise<number[]>;
    update(start: number, data: number[]): Promise<number[]>;
    append(data: number[]): Promise<void>;
    truncate(size: number): Promise<void>;
    unlink(file: string): Promise<void>;
}
export {};
