import { ecb } from '@noble/ciphers/aes';
export declare class CryptoHelper {
    protected static readonly CachedCipher: Map<string, import("@noble/ciphers/utils").CipherWithOutput>;
    static RandomBytes(size: number): Uint8Array;
    static Utf8ToBytes(text: string): Uint8Array;
    static HexToBytes(hex: string): Uint8Array;
    static NumberToBytesBe(num: number | bigint): Uint8Array;
    static BytesToNumberBe(bytes: Uint8Array): bigint;
    static BytesToUtf8(bytes: Uint8Array): string;
    static BytesToHex(bytes: Uint8Array): string;
    protected static GetCipher(key: Uint8Array): ReturnType<typeof ecb>;
    static Encrypt(plain: string, key: Uint8Array): string;
    static Decrypt(hash: string, key: Uint8Array): string;
}
